/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech) (3.1.2).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
package org.openapitools.v1_0.api;

import org.openapitools.v1_0.model.Error;
import org.openapitools.v1_0.model.Viewer;
import io.swagger.annotations.*;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;
import java.util.Optional;
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2023-09-15T12:23:18.056Z[GMT]")

@Validated
@Api(value = "viewer", description = "the viewer API")
public interface ViewerApi {

    default Optional<NativeWebRequest> getRequest() {
        return Optional.empty();
    }

    @ApiOperation(value = "Deploys serviceType and creates a data directory/sessionId if necessary.", nickname = "createViewer", notes = "Deploys a serviceType (adaguc or enlighten). If no sessionId is provided, it will also create a data directory that is read-only from the prespective of the serviceType, but that can be written to by submitting workflow jobs through the /workflow/_* API endpoints. A working directory that can be written to from the serviceType is also created.", response = Viewer.class, tags={ "viewer", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success", response = Viewer.class),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/viewer/{serviceType}",
        produces = { "application/json" }, 
        consumes = { "application/json", "application/xml" },
        method = RequestMethod.POST)
    default ResponseEntity<?> createViewer(@ApiParam(value = "serviceType of the new viewer service, currently only adaguc and enlighten are supported",required=true) @PathVariable("serviceType") String serviceType,@ApiParam(value = "Viewer service"  )  @Valid @RequestBody Viewer viewer) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    ApiUtil.setExampleResponse(request, "application/json", "null");
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Deletes Viewer service for the given viewerId.", nickname = "deleteViewer", notes = "Deletes viewer for given viewer-Id. The corresponding session is not deleted.", tags={ "viewer", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success"),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/viewer/{serviceType}/{id}",
        produces = { "application/json" }, 
        method = RequestMethod.DELETE)
    default ResponseEntity<?> deleteViewer(@ApiParam(value = "serviceType of the viewer service to be deleted, currently only adaguc and enlighten are supported",required=true) @PathVariable("serviceType") String serviceType,@ApiParam(value = "Id of the running Viewer service.",required=true) @PathVariable("id") String id) {
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Retrieves the running viewer service for the given viewerId.", nickname = "getViewer", notes = "Retrieves the running viewer service for the given viewerId", response = Viewer.class, tags={ "viewer", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success", response = Viewer.class),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/viewer/{serviceType}/{id}",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    default ResponseEntity<?> getViewer(@ApiParam(value = "serviceType of the running viewer service, currently only adaguc and enlighten are supported",required=true) @PathVariable("serviceType") String serviceType,@ApiParam(value = "Id of the running viewer service.",required=true) @PathVariable("id") String id) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    ApiUtil.setExampleResponse(request, "application/json", "null");
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }

}
